local goTimer = LibStub("AceAddon-3.0"):NewAddon("goTimer", "AceTimer-3.0", "AceConsole-3.0", "AceEvent-3.0")

local showBigGo = false

local _G = getfenv(0)

local function createOptions()
	--slash command setup
	local options = {
		type="group",
		args = {
			start = {
				name = "Start", type = 'execute',
				desc = "Start Countdown",
				disabled = function() return not goTimer:isRaid() end,
				func = function()
					goTimer:ScheduleCountdownEvents();
				end
			},
			stop = {
				name = "Stop", type = 'execute',
				desc = "Emergency Stop",
				disabled = function() return not goTimer:isRaid() end,
				func = function()
					goTimer:EmergencyStop();
				end
			}
		}
	}
	
	return options;
end
	
function goTimer:OnInitialize()	
	
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("goTimer", createOptions)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("goTimer", "goTimer")
	LibStub("AceConfigCmd-3.0"):CreateChatCommand("gotimer", "goTimer")	
	
end

function goTimer:isRaid() 

	if (GetNumRaidMembers() == 0) then
		return false
	else
		return true
	end
end

function goTimer:ScheduleCountdownEvents()
	self:goTimer_Message("countdown initiated - prepare for battle..")
	self:goTimer_Message("timer startet, 15 left - stop with /gotimer stop", true)
	
	--self:ScheduleTimer("goTimer_Message", 2, "test");
	
	self:ScheduleTimer("goTimer_Message", 5, "10s to go..." )
	self:ScheduleTimer("goTimer_Message", 10, "5..." )
	self:ScheduleTimer("goTimer_Message", 11, "4..." )
	self:ScheduleTimer("goTimer_Message", 12, "3..." )
	self:ScheduleTimer("goTimer_Message", 13, "2..." )
	self:ScheduleTimer("goTimer_Message", 14, "1..." )
	self:ScheduleTimer("goTimer_Message", 15, "GO!" )
	
end

function goTimer:EmergencyStop() 
	self:CancelAllTimers()
	self:goTimer_Message("timer stopped", true)
	self:goTimer_Message("countdown aborted - wait for further instructions")
end

function goTimer:goTimer_Message(message, noRW) 

	if not message then 
		self:Print("no message found")
		return 
	end 
	
	if not noRW and goTimer:isRaid() then
		SendChatMessage(message,"RAID_WARNING")
		if (message == "GO!" and showBigGo) then	
			SendChatMessage("                        O      O","RAID")
			SendChatMessage(".","RAID")
			SendChatMessage(" WWWW:       WWW* ","RAID")
			SendChatMessage("WW  WW     WW      W*","RAID")
			SendChatMessage("W      WW    W          :W","RAID")
			SendChatMessage("W.     WW    W         W","RAID")		
			SendChatMessage("  WW WW       WWW  ","RAID")
			SendChatMessage(".        WW","RAID")
			SendChatMessage("W#      .W","RAID")
			SendChatMessage(" WWWW","RAID")
		end
	else
		self:Print(message)
	end	
end



function goTimer:OnEnable()
	self:RegisterEvent("goTimer_Message")
end
